;DRAW TUBE - baah/Positivity, 2011 may
;IN:  a6=@VRAM
;OUT: KILLS EVERYTHING

NbSin=1024  ;Nb of Sinus Values, one word each
SinN=12     ;Shift for values in Sinus table
SizeN=8     ;log2(Nb of values in TubeSizeCurves), one word each, must be <SinN
;If SizeN+1=SinN+1 then "lsr.w     #SinN-SizeN,d0" is useless

;Increment angles  
  lea       AnglesAndIncrements(pc),a5
  movem.w   (a5),d0-d2/d6-d7/a0-a1 ;d0-d1=angles, d2+d6=TubeSizeIncrement*16, d7=mask=(NbSin-1)*2, a0-a1=increments
  add.w     a0,d0               ;a0+=increment
  and.w     d7,d0               ;angle a0 in [0;NbSin[*2
  add.w     a1,d1               ;a1
  and.w     d7,d1
  add.w     d2,d6               ;TubeSizeIncrement+=d2
  bne.s     multiplierok1
multiplierok2:
  neg.w     d2
  add.w     d2,d6
multiplierok1:
  cmp.w     #153,d6
  bge.s     multiplierok2       ;Here TubeSizeIncrement*16 is in ]0;153[
  movem.w   d0-d2/d6,(a5)       ;Save modified values
  add.w     d6,d6               ;d6.w=TubeSizeIncrement*2
  move.w    #2*((1<<SizeN)-1),d7;d7.w=mask for TubeSizeIncrement
;Compute Multiplier=int(5*(sin(a0)+sin(a1)/2)+7.5) in [0;15]
  lea       Sinus(pc),a5
  move.w    (a5,d0.w),d0        ;d0.w=sin(a0)<<SinN
  add.w     d0,d0               ;d0.w=2*sin(a0)<<SinN
  add.w     (a5,d1.w),d0        ;d0.w=(sin(a0)+sin(a1)/2)<<SinN+1
  asr.w     #SinN-SizeN,d0      ;d0.w=(sin(a0)+sin(a1)/2)<<SizeN+1
  move.w    d0,d1
  add.w     d0,d0
  add.w     d0,d0
  add.w     d1,d0               ;d0.w=5*(sin(a0)+sin(a1)/2)<<SizeN+1
;!!!  add.w     #7.5<<(SizeN+1),d0 ;d0.w=5*(sin(a0)+sin(a1)/2+1.5)<<SizeN+1
  add.w     #15<<SizeN,d0       ;d0.w=5*(sin(a0)+sin(a1)/2+1.5)<<SizeN+1
  and.w     #$7f<<(SizeN+1),d0  ;d0.w=int(5*(sin(a0)+sin(a1)/2+1.5))<<SizeN+1
  lea       TubeSizeCurves(pc),a5
  add.w     d0,a5               ;a5 points on correct TubeSizeCurve
  
;Go to correct position in RotationIncrements
  lea       RotationIncrementsPosition(pc),a3
  move.w    (a3),d0
  subq.w    #2,d0
  bge.s     RotationIncrementsPositionOk
  move.w    -2(a3),d0
RotationIncrementsPositionOk  
  move.w    d0,(a3)+
  add.w     d0,a3               ;a3 points on rotation increments

;Compute RotationStartAngle
  move.w    #63<<5,d4           ;mask for 64 lines, 32 bytes each
  move.w    startangle,d3
  add.w     #59<<5,d3           ;RotationStartAngle+=inc
  and.w     d4,d3
  move.w    d3,startangle


  lea       TubeSizeCurveMiddle(pc),a4
  movem.w   (a4),d0/d5
  add.w     d0,d5
  bne.s     TubeSizeCurveMiddleOk1
  neg.w     d0
TubeSizeCurveMiddleOk1:  
  cmp.w     #-199,d5
  bge.s     TubeSizeCurveMiddleOk2
  neg.w     d0
TubeSizeCurveMiddleOk2
  movem.w   d0/d5,(a4)
    
  lea       Tubes(pc),a4
  
  muls.w    d6,d5                 ;TubeSizeCurvePos=Middle*Increment
        
;d7.w=mask for TubeSizeIncrement=(2<<(SizeN+1)-1)*16*2
;d6.w=TubeSizeIncrement*16*2
;d5.w=TubeSizeCurvePos*16*2
;d4.w=mask for RotationAngle
;d3.w=RotationAngle
;a6.l=@vram
;a5.l=@TubeSizeCurves
;a4.l=@Tubes
;a3.l=@RotationIncrements

;DrawOneLine
offset SET 48
 REPT 200
  move.w    d3,d2               ;d2=RotationAngle
  and.w     d4,d2               ;modulo
  add.w     (a3)+,d3            ;RotationAngle+=RotationIncrement

  move.w    d5,d0               ;d0=TubeSizeCurvePos*16*2
  lsr.w     #4,d0               ;d0=TubeSizeCurvePos*2
  and.w     d7,d0               ;modulo
  add.w     (a5,d0.w),d2        ;d2+=TubeSize(TubeSizeCurvePos)
  add.w     d6,d5               ;TubeSizeCurvePos+=TubeSizeIncrement

  movem.l   (a4,d2.w),d0-d1/a0-a1
  move.l    d0,offset(a6)
  move.l    d1,offset+8(a6)
  move.l    a0,offset+16(a6)
  move.l    a1,offset+24(a6)
  movem.l   16(a4,d2.w),d0-d1/a0-a1
  move.l    d0,offset+32(a6)
  move.l    d1,offset+40(a6)
  move.l    a0,offset+48(a6)
  move.l    a1,offset+56(a6)
  
offset SET offset+160
 ENDR
;  dbra d5,DrawOneLine
  
  rts
  
startangle:
  dc.w      0
 
AnglesAndIncrements
  dc.w  0,0          ;angles
  dc.w  1,1          ;TubeSizeIncrementIncrement and TubeSizeIncrement
  dc.w  (NbSin-1)*2  ;mask
  dc.w  11*2,2*2     ;increments

TubeSizeCurveMiddle
  dc.w  -1,-100
  
Sinus:
 dc.w 0,25,50,75,100,125,150,175,200,226,251,276,301,326,351,376,401,426,451,476,501,526,551,576,601,625,650,675,700,725,749,774
 dc.w 799,823,848,872,897,921,946,970,995,1019,1043,1068,1092,1116,1140,1164,1189,1213,1237,1260,1284,1308,1332,1356,1379,1403,1427,1450,1474,1497,1520,1544
 dc.w 1567,1590,1613,1636,1659,1682,1705,1728,1751,1773,1796,1819,1841,1864,1886,1908,1930,1952,1975,1997,2018,2040,2062,2084,2105,2127,2148,2170,2191,2212,2233,2254
 dc.w 2275,2296,2317,2337,2358,2379,2399,2419,2439,2460,2480,2500,2519,2539,2559,2578,2598,2617,2637,2656,2675,2694,2713,2732,2750,2769,2787,2806,2824,2842,2860,2878
 dc.w 2896,2914,2931,2949,2966,2983,3000,3018,3034,3051,3068,3085,3101,3117,3134,3150,3166,3182,3197,3213,3229,3244,3259,3274,3289,3304,3319,3334,3348,3363,3377,3391
 dc.w 3405,3419,3433,3447,3460,3473,3487,3500,3513,3526,3538,3551,3563,3576,3588,3600,3612,3624,3635,3647,3658,3669,3680,3691,3702,3713,3723,3734,3744,3754,3764,3774
 dc.w 3784,3793,3803,3812,3821,3830,3839,3848,3856,3864,3873,3881,3889,3897,3904,3912,3919,3926,3933,3940,3947,3954,3960,3967,3973,3979,3985,3990,3996,4001,4007,4012
 dc.w 4017,4022,4026,4031,4035,4039,4043,4047,4051,4055,4058,4062,4065,4068,4071,4073,4076,4078,4080,4082,4084,4086,4088,4089,4091,4092,4093,4094,4094,4095,4095,4095
 dc.w 4096,4095,4095,4095,4094,4094,4093,4092,4091,4089,4088,4086,4084,4082,4080,4078,4076,4073,4071,4068,4065,4062,4058,4055,4051,4047,4043,4039,4035,4031,4026,4022
 dc.w 4017,4012,4007,4001,3996,3990,3985,3979,3973,3967,3960,3954,3947,3940,3933,3926,3919,3912,3904,3897,3889,3881,3873,3864,3856,3848,3839,3830,3821,3812,3803,3793
 dc.w 3784,3774,3764,3754,3744,3734,3723,3713,3702,3691,3680,3669,3658,3647,3635,3624,3612,3600,3588,3576,3563,3551,3538,3526,3513,3500,3487,3473,3460,3447,3433,3419
 dc.w 3405,3391,3377,3363,3348,3334,3319,3304,3289,3274,3259,3244,3229,3213,3197,3182,3166,3150,3134,3117,3101,3085,3068,3051,3034,3018,3000,2983,2966,2949,2931,2914
 dc.w 2896,2878,2860,2842,2824,2806,2787,2769,2750,2732,2713,2694,2675,2656,2637,2617,2598,2578,2559,2539,2519,2500,2480,2460,2439,2419,2399,2379,2358,2337,2317,2296
 dc.w 2275,2254,2233,2212,2191,2170,2148,2127,2105,2084,2062,2040,2018,1997,1975,1952,1930,1908,1886,1864,1841,1819,1796,1773,1751,1728,1705,1682,1659,1636,1613,1590
 dc.w 1567,1544,1520,1497,1474,1450,1427,1403,1379,1356,1332,1308,1284,1260,1237,1213,1189,1164,1140,1116,1092,1068,1043,1019,995,970,946,921,897,872,848,823
 dc.w 799,774,749,725,700,675,650,625,601,576,551,526,501,476,451,426,401,376,351,326,301,276,251,226,200,175,150,125,100,75,50,25
 dc.w 0,-25,-50,-75,-100,-125,-150,-175,-200,-226,-251,-276,-301,-326,-351,-376,-401,-426,-451,-476,-501,-526,-551,-576,-601,-625,-650,-675,-700,-725,-749,-774
 dc.w -799,-823,-848,-872,-897,-921,-946,-970,-995,-1019,-1043,-1068,-1092,-1116,-1140,-1164,-1189,-1213,-1237,-1260,-1284,-1308,-1332,-1356,-1379,-1403,-1427,-1450,-1474,-1497,-1520,-1544
 dc.w -1567,-1590,-1613,-1636,-1659,-1682,-1705,-1728,-1751,-1773,-1796,-1819,-1841,-1864,-1886,-1908,-1930,-1952,-1975,-1997,-2018,-2040,-2062,-2084,-2105,-2127,-2148,-2170,-2191,-2212,-2233,-2254
 dc.w -2275,-2296,-2317,-2337,-2358,-2379,-2399,-2419,-2439,-2460,-2480,-2500,-2519,-2539,-2559,-2578,-2598,-2617,-2637,-2656,-2675,-2694,-2713,-2732,-2750,-2769,-2787,-2806,-2824,-2842,-2860,-2878
 dc.w -2896,-2914,-2931,-2949,-2966,-2983,-3000,-3018,-3034,-3051,-3068,-3085,-3101,-3117,-3134,-3150,-3166,-3182,-3197,-3213,-3229,-3244,-3259,-3274,-3289,-3304,-3319,-3334,-3348,-3363,-3377,-3391
 dc.w -3405,-3419,-3433,-3447,-3460,-3473,-3487,-3500,-3513,-3526,-3538,-3551,-3563,-3576,-3588,-3600,-3612,-3624,-3635,-3647,-3658,-3669,-3680,-3691,-3702,-3713,-3723,-3734,-3744,-3754,-3764,-3774
 dc.w -3784,-3793,-3803,-3812,-3821,-3830,-3839,-3848,-3856,-3864,-3873,-3881,-3889,-3897,-3904,-3912,-3919,-3926,-3933,-3940,-3947,-3954,-3960,-3967,-3973,-3979,-3985,-3990,-3996,-4001,-4007,-4012
 dc.w -4017,-4022,-4026,-4031,-4035,-4039,-4043,-4047,-4051,-4055,-4058,-4062,-4065,-4068,-4071,-4073,-4076,-4078,-4080,-4082,-4084,-4086,-4088,-4089,-4091,-4092,-4093,-4094,-4094,-4095,-4095,-4095
 dc.w -4096,-4095,-4095,-4095,-4094,-4094,-4093,-4092,-4091,-4089,-4088,-4086,-4084,-4082,-4080,-4078,-4076,-4073,-4071,-4068,-4065,-4062,-4058,-4055,-4051,-4047,-4043,-4039,-4035,-4031,-4026,-4022
 dc.w -4017,-4012,-4007,-4001,-3996,-3990,-3985,-3979,-3973,-3967,-3960,-3954,-3947,-3940,-3933,-3926,-3919,-3912,-3904,-3897,-3889,-3881,-3873,-3864,-3856,-3848,-3839,-3830,-3821,-3812,-3803,-3793
 dc.w -3784,-3774,-3764,-3754,-3744,-3734,-3723,-3713,-3702,-3691,-3680,-3669,-3658,-3647,-3635,-3624,-3612,-3600,-3588,-3576,-3563,-3551,-3538,-3526,-3513,-3500,-3487,-3473,-3460,-3447,-3433,-3419
 dc.w -3405,-3391,-3377,-3363,-3348,-3334,-3319,-3304,-3289,-3274,-3259,-3244,-3229,-3213,-3197,-3182,-3166,-3150,-3134,-3117,-3101,-3085,-3068,-3051,-3034,-3018,-3000,-2983,-2966,-2949,-2931,-2914
 dc.w -2896,-2878,-2860,-2842,-2824,-2806,-2787,-2769,-2750,-2732,-2713,-2694,-2675,-2656,-2637,-2617,-2598,-2578,-2559,-2539,-2519,-2500,-2480,-2460,-2439,-2419,-2399,-2379,-2358,-2337,-2317,-2296
 dc.w -2275,-2254,-2233,-2212,-2191,-2170,-2148,-2127,-2105,-2084,-2062,-2040,-2018,-1997,-1975,-1952,-1930,-1908,-1886,-1864,-1841,-1819,-1796,-1773,-1751,-1728,-1705,-1682,-1659,-1636,-1613,-1590
 dc.w -1567,-1544,-1520,-1497,-1474,-1450,-1427,-1403,-1379,-1356,-1332,-1308,-1284,-1260,-1237,-1213,-1189,-1164,-1140,-1116,-1092,-1068,-1043,-1019,-995,-970,-946,-921,-897,-872,-848,-823
 dc.w -799,-774,-749,-725,-700,-675,-650,-625,-601,-576,-551,-526,-501,-476,-451,-426,-401,-376,-351,-326,-301,-276,-251,-226,-200,-175,-150,-125,-100,-75,-50,-25

TubeSizeCurves:
 dc.w 14336,14336,14336,12288,12288,12288,12288,12288,12288,10240,10240,10240,10240,10240,8192,8192,8192,8192,8192,8192,6144,6144,6144,6144,6144,6144,6144,4096,4096,4096,4096,4096
 dc.w 4096,4096,2048,2048,2048,2048,2048,2048,2048,2048,2048,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2048,2048,2048,2048,2048,2048,2048,2048,2048,4096
 dc.w 4096,4096,4096,4096,4096,4096,6144,6144,6144,6144,6144,6144,6144,8192,8192,8192,8192,8192,8192,10240,10240,10240,10240,10240,12288,12288,12288,12288,12288,12288,14336,14336
 dc.w 14336,14336,14336,16384,16384,16384,16384,16384,16384,18432,18432,18432,18432,18432,20480,20480,20480,20480,20480,20480,22528,22528,22528,22528,22528,22528,22528,24576,24576,24576,24576,24576
 dc.w 24576,24576,26624,26624,26624,26624,26624,26624,26624,26624,26624,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672
 dc.w 30720,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,26624,26624,26624,26624,26624,26624,26624,26624,26624,24576
 dc.w 24576,24576,24576,24576,24576,24576,22528,22528,22528,22528,22528,22528,22528,20480,20480,20480,20480,20480,20480,18432,18432,18432,18432,18432,16384,16384,16384,16384,16384,16384,14336,14336
 dc.w 14336,14336,14336,14336,12288,12288,12288,12288,12288,12288,10240,10240,10240,10240,10240,10240,10240,8192,8192,8192,8192,8192,8192,8192,6144,6144,6144,6144,6144,6144,6144,6144
 dc.w 4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048
 dc.w 2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,4096,4096,4096,4096,4096,4096,4096,4096,4096
 dc.w 4096,6144,6144,6144,6144,6144,6144,6144,6144,8192,8192,8192,8192,8192,8192,8192,10240,10240,10240,10240,10240,10240,10240,12288,12288,12288,12288,12288,12288,14336,14336,14336
 dc.w 14336,14336,14336,14336,16384,16384,16384,16384,16384,16384,18432,18432,18432,18432,18432,18432,18432,20480,20480,20480,20480,20480,20480,20480,22528,22528,22528,22528,22528,22528,22528,22528
 dc.w 24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624
 dc.w 28672,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,24576,24576,24576,24576,24576,24576,24576,24576,24576
 dc.w 24576,22528,22528,22528,22528,22528,22528,22528,22528,20480,20480,20480,20480,20480,20480,20480,18432,18432,18432,18432,18432,18432,18432,16384,16384,16384,16384,16384,16384,14336,14336,14336
 dc.w 14336,14336,14336,14336,12288,12288,12288,12288,12288,12288,12288,12288,10240,10240,10240,10240,10240,10240,10240,10240,8192,8192,8192,8192,8192,8192,8192,8192,8192,6144,6144,6144
 dc.w 6144,6144,6144,6144,6144,6144,6144,6144,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096
 dc.w 4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,6144,6144,6144,6144,6144,6144,6144
 dc.w 6144,6144,6144,6144,8192,8192,8192,8192,8192,8192,8192,8192,8192,10240,10240,10240,10240,10240,10240,10240,10240,12288,12288,12288,12288,12288,12288,12288,12288,14336,14336,14336
 dc.w 14336,14336,14336,14336,16384,16384,16384,16384,16384,16384,16384,16384,18432,18432,18432,18432,18432,18432,18432,18432,20480,20480,20480,20480,20480,20480,20480,20480,20480,22528,22528,22528
 dc.w 22528,22528,22528,22528,22528,22528,22528,22528,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576
 dc.w 26624,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,22528,22528,22528,22528,22528,22528,22528
 dc.w 22528,22528,22528,22528,20480,20480,20480,20480,20480,20480,20480,20480,20480,18432,18432,18432,18432,18432,18432,18432,18432,16384,16384,16384,16384,16384,16384,16384,16384,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,12288,12288,12288,12288,12288,12288,12288,12288,12288,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,8192,8192,8192,8192,8192,8192,8192,8192
 dc.w 8192,8192,8192,8192,8192,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144
 dc.w 6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,8192,8192,8192,8192
 dc.w 8192,8192,8192,8192,8192,8192,8192,8192,8192,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,12288,12288,12288,12288,12288,12288,12288,12288,12288,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,16384,16384,16384,16384,16384,16384,16384,16384,16384,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,20480,20480,20480,20480,20480,20480,20480,20480
 dc.w 20480,20480,20480,20480,20480,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528
 dc.w 24576,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,20480,20480,20480,20480
 dc.w 20480,20480,20480,20480,20480,20480,20480,20480,20480,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,16384,16384,16384,16384,16384,16384,16384,16384,16384,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240
 dc.w 10240,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192
 dc.w 8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192
 dc.w 10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432
 dc.w 18432,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480
 dc.w 22528,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480
 dc.w 18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,10240,10240,10240,10240,10240
 dc.w 10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240
 dc.w 10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240
 dc.w 10240,10240,10240,10240,10240,10240,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,18432,18432,18432,18432,18432
 dc.w 18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432
 dc.w 20480,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432
 dc.w 18432,18432,18432,18432,18432,18432,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288
 dc.w 12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288
 dc.w 12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288
 dc.w 12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384
 dc.w 16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384
 dc.w 18432,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384
 dc.w 16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 16384,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 16384,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384
 dc.w 16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384
 dc.w 18432,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384
 dc.w 16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288
 dc.w 12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288
 dc.w 12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288
 dc.w 12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,18432,18432,18432,18432,18432
 dc.w 18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432
 dc.w 20480,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432
 dc.w 18432,18432,18432,18432,18432,18432,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,14336,14336,14336,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,10240,10240,10240,10240,10240
 dc.w 10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240
 dc.w 10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240
 dc.w 10240,10240,10240,10240,10240,10240,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,14336,14336,14336,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432
 dc.w 18432,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480
 dc.w 22528,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480,20480
 dc.w 18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,16384,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,14336,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240
 dc.w 10240,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192
 dc.w 8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192
 dc.w 10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,12288,14336,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,16384,16384,16384,16384,16384,16384,16384,16384,16384,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,20480,20480,20480,20480,20480,20480,20480,20480
 dc.w 20480,20480,20480,20480,20480,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528
 dc.w 24576,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,22528,20480,20480,20480,20480
 dc.w 20480,20480,20480,20480,20480,20480,20480,20480,20480,18432,18432,18432,18432,18432,18432,18432,18432,18432,18432,16384,16384,16384,16384,16384,16384,16384,16384,16384,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,14336,12288,12288,12288,12288,12288,12288,12288,12288,12288,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,8192,8192,8192,8192,8192,8192,8192,8192
 dc.w 8192,8192,8192,8192,8192,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144
 dc.w 6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,6144,8192,8192,8192,8192
 dc.w 8192,8192,8192,8192,8192,8192,8192,8192,8192,10240,10240,10240,10240,10240,10240,10240,10240,10240,10240,12288,12288,12288,12288,12288,12288,12288,12288,12288,14336,14336,14336,14336
 dc.w 14336,14336,14336,14336,16384,16384,16384,16384,16384,16384,16384,16384,18432,18432,18432,18432,18432,18432,18432,18432,20480,20480,20480,20480,20480,20480,20480,20480,20480,22528,22528,22528
 dc.w 22528,22528,22528,22528,22528,22528,22528,22528,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576
 dc.w 26624,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,22528,22528,22528,22528,22528,22528,22528
 dc.w 22528,22528,22528,22528,20480,20480,20480,20480,20480,20480,20480,20480,20480,18432,18432,18432,18432,18432,18432,18432,18432,16384,16384,16384,16384,16384,16384,16384,16384,14336,14336,14336
 dc.w 14336,14336,14336,14336,12288,12288,12288,12288,12288,12288,12288,12288,10240,10240,10240,10240,10240,10240,10240,10240,8192,8192,8192,8192,8192,8192,8192,8192,8192,6144,6144,6144
 dc.w 6144,6144,6144,6144,6144,6144,6144,6144,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096
 dc.w 4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,6144,6144,6144,6144,6144,6144,6144
 dc.w 6144,6144,6144,6144,8192,8192,8192,8192,8192,8192,8192,8192,8192,10240,10240,10240,10240,10240,10240,10240,10240,12288,12288,12288,12288,12288,12288,12288,12288,14336,14336,14336
 dc.w 14336,14336,14336,14336,16384,16384,16384,16384,16384,16384,18432,18432,18432,18432,18432,18432,18432,20480,20480,20480,20480,20480,20480,20480,22528,22528,22528,22528,22528,22528,22528,22528
 dc.w 24576,24576,24576,24576,24576,24576,24576,24576,24576,24576,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624
 dc.w 28672,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,26624,24576,24576,24576,24576,24576,24576,24576,24576,24576
 dc.w 24576,22528,22528,22528,22528,22528,22528,22528,22528,20480,20480,20480,20480,20480,20480,20480,18432,18432,18432,18432,18432,18432,18432,16384,16384,16384,16384,16384,16384,14336,14336,14336
 dc.w 14336,14336,14336,14336,12288,12288,12288,12288,12288,12288,10240,10240,10240,10240,10240,10240,10240,8192,8192,8192,8192,8192,8192,8192,6144,6144,6144,6144,6144,6144,6144,6144
 dc.w 4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048
 dc.w 2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,4096,4096,4096,4096,4096,4096,4096,4096,4096
 dc.w 4096,6144,6144,6144,6144,6144,6144,6144,6144,8192,8192,8192,8192,8192,8192,8192,10240,10240,10240,10240,10240,10240,10240,12288,12288,12288,12288,12288,12288,14336,14336,14336
 dc.w 14336,14336,14336,16384,16384,16384,16384,16384,16384,18432,18432,18432,18432,18432,20480,20480,20480,20480,20480,20480,22528,22528,22528,22528,22528,22528,22528,24576,24576,24576,24576,24576
 dc.w 24576,24576,26624,26624,26624,26624,26624,26624,26624,26624,26624,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672
 dc.w 30720,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,26624,26624,26624,26624,26624,26624,26624,26624,26624,24576
 dc.w 24576,24576,24576,24576,24576,24576,22528,22528,22528,22528,22528,22528,22528,20480,20480,20480,20480,20480,20480,18432,18432,18432,18432,18432,16384,16384,16384,16384,16384,16384,14336,14336
 dc.w 14336,14336,14336,12288,12288,12288,12288,12288,12288,10240,10240,10240,10240,10240,8192,8192,8192,8192,8192,8192,6144,6144,6144,6144,6144,6144,6144,4096,4096,4096,4096,4096
 dc.w 4096,4096,2048,2048,2048,2048,2048,2048,2048,2048,2048,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2048,2048,2048,2048,2048,2048,2048,2048,2048,4096
 dc.w 4096,4096,4096,4096,4096,4096,6144,6144,6144,6144,6144,6144,6144,8192,8192,8192,8192,8192,8192,10240,10240,10240,10240,10240,12288,12288,12288,12288,12288,12288,14336,14336
 
 dc.w 14336,14336,14336,12288,12288,12288,12288,12288,12288,10240,10240,10240,10240,10240,8192,8192,8192,8192,8192,8192,6144,6144,6144,6144,6144,6144,6144,4096,4096,4096,4096,4096
 dc.w 4096,4096,2048,2048,2048,2048,2048,2048,2048,2048,2048,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2048,2048,2048,2048,2048,2048,2048,2048,2048,4096
 dc.w 4096,4096,4096,4096,4096,4096,6144,6144,6144,6144,6144,6144,6144,8192,8192,8192,8192,8192,8192,10240,10240,10240,10240,10240,12288,12288,12288,12288,12288,12288,14336,14336
 dc.w 14336,14336,14336,16384,16384,16384,16384,16384,16384,18432,18432,18432,18432,18432,20480,20480,20480,20480,20480,20480,22528,22528,22528,22528,22528,22528,22528,24576,24576,24576,24576,24576
 dc.w 24576,24576,26624,26624,26624,26624,26624,26624,26624,26624,26624,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672
 dc.w 30720,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,26624,26624,26624,26624,26624,26624,26624,26624,26624,24576
 dc.w 24576,24576,24576,24576,24576,24576,22528,22528,22528,22528,22528,22528,22528,20480,20480,20480,20480,20480,20480,18432,18432,18432,18432,18432,16384,16384,16384,16384,16384,16384,14336,14336
 dc.w 14336,14336,14336,12288,12288,12288,12288,12288,12288,10240,10240,10240,10240,10240,8192,8192,8192,8192,8192,8192,6144,6144,6144,6144,6144,6144,6144,4096,4096,4096,4096,4096
 dc.w 4096,4096,2048,2048,2048,2048,2048,2048,2048,2048,2048,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2048,2048,2048,2048,2048,2048,2048,2048,2048,4096
 dc.w 4096,4096,4096,4096,4096,4096,6144,6144,6144,6144,6144,6144,6144,8192,8192,8192,8192,8192,8192,10240,10240,10240,10240,10240,12288,12288,12288,12288,12288,12288,14336,14336
 dc.w 14336,14336,14336,16384,16384,16384,16384,16384,16384,18432,18432,18432,18432,18432,20480,20480,20480,20480,20480,20480,22528,22528,22528,22528,22528,22528,22528,24576,24576,24576,24576,24576
 dc.w 24576,24576,26624,26624,26624,26624,26624,26624,26624,26624,26624,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672
 dc.w 30720,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,28672,26624,26624,26624,26624,26624,26624,26624,26624,26624,24576
 dc.w 24576,24576,24576,24576,24576,24576,22528,22528,22528,22528,22528,22528,22528,20480,20480,20480,20480,20480,20480,18432,18432,18432,18432,18432,16384,16384,16384,16384,16384,16384,14336,14336
 
 dc.w (1696-1)*2 ;Number of values
RotationIncrementsPosition
 dc.w 0
RotationIncrements
 dc.w 24,24,25,25,26,26,26,27,27,27,27,28,28,28,28,28,28,27,27,27,27,26,26,25,25,24,24,23,23,22,21,20
 dc.w 20,19,18,17,17,16,16,15,15,15,15,15,15,15,15,15,16,16,17,17,18,19,20,21,22,23,24,25,26,28,29,31
 dc.w 33,34,36,37,39,40,42,43,44,46,47,48,49,50,50,51,52,53,53,54,54,55,55,55,55,55,56,56,55,55,55,55
 dc.w 55,54,54,53,53,53,52,52,51,51,51,50,50,49,49,49,48,48,47,47,47,46,46,45,45,45,44,44,43,43,42,42
 dc.w 42,41,41,40,40,39,39,38,38,37,37,36,36,35,35,34,34,33,33,32,32,31,31,30,30,29,29,28,28,27,27,26
 dc.w 26,25,24,24,23,23,23,22,22,21,21,21,21,20,20,20,20,20,19,19,19,19,19,19,19,19,19,20,20,20,20,20
 dc.w 21,21,21,21,21,21,21,22,22,22,22,21,21,21,21,21,21,21,20,20,20,19,19,19,18,18,17,17,16,15,15,14
 dc.w 14,13,12,12,11,11,11,11,11,11,11,11,11,11,12,12,13,13,14,15,16,17,18,19,20,21,23,24,26,27,29,31
 dc.w 33,34,36,38,39,41,42,44,45,46,47,48,49,50,50,51,52,52,52,53,53,53,53,53,53,53,52,52,51,51,50,49
 dc.w 49,48,47,46,45,45,44,43,43,42,42,41,41,40,40,40,40,39,39,39,39,39,39,39,39,39,39,39,39,40,40,40
 dc.w 41,41,41,42,42,42,42,43,43,43,43,44,44,44,44,44,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45
 dc.w 45,44,44,44,44,44,43,43,43,42,42,42,41,41,40,40,39,39,38,38,37,36,36,35,34,33,33,32,31,30,29,28
 dc.w 28,27,26,25,24,24,23,22,22,21,21,21,20,20,20,20,20,20,20,20,20,20,21,21,21,22,22,23,23,24,25,26
 dc.w 27,27,28,29,29,30,31,31,31,32,32,32,32,32,32,32,32,32,32,31,31,31,30,30,29,28,27,27,26,25,24,23
 dc.w 22,20,19,18,17,16,16,15,14,14,13,13,13,12,12,12,12,12,12,12,13,13,13,14,14,15,16,16,17,18,19,20
 dc.w 22,23,24,25,26,27,28,29,30,31,32,33,34,34,35,36,37,37,38,39,39,40,41,41,42,42,42,43,43,44,44,44
 dc.w 45,45,45,45,45,46,46,46,46,45,45,45,45,45,44,44,44,43,43,42,42,41,41,40,39,38,37,37,36,35,34,33
 dc.w 32,30,29,28,28,27,26,25,24,23,23,22,21,20,20,19,19,18,18,17,17,17,16,16,16,15,15,15,15,15,15,15
 dc.w 15,15,15,15,15,15,15,15,15,15,15,16,16,16,16,17,17,17,18,18,18,19,19,20,20,21,21,22,22,23,23,24
 dc.w 25,25,26,26,27,28,28,29,29,30,30,31,31,31,32,32,32,33,33,33,33,33,33,34,34,34,34,34,34,34,34,34
 dc.w 34,33,33,33,33,33,33,32,32,32,32,31,31,30,30,29,29,28,28,27,27,26,26,25,24,23,23,22,21,20,19,18
 dc.w 18,17,16,15,14,14,13,12,12,11,11,11,10,10,10,9,9,9,9,9,9,9,9,9,9,10,10,10,11,11,11,12
 dc.w 13,13,14,14,15,16,16,17,18,19,19,20,21,22,23,23,24,25,26,27,28,29,30,30,31,32,33,34,35,36,37,38
 dc.w 40,41,41,42,43,44,45,45,46,46,47,47,47,47,47,48,48,47,47,47,47,46,46,45,45,44,43,43,42,41,40,39
 dc.w 38,36,35,34,34,33,32,31,31,30,30,29,29,29,29,29,29,29,29,29,29,30,30,31,31,32,33,33,34,35,36,37
 dc.w 39,40,41,42,43,44,45,46,47,47,48,49,50,50,51,51,52,52,53,53,54,54,54,54,55,55,55,55,55,55,55,55
 dc.w 55,54,54,54,54,53,53,53,52,52,51,51,50,50,49,49,48,47,47,46,45,45,44,43,42,41,40,39,39,38,37,36
 dc.w 35,34,33,32,31,30,29,28,28,27,26,26,25,25,24,24,24,23,23,23,22,22,22,22,22,22,22,22,22,22,22,22
 dc.w 23,23,23,23,23,23,23,24,24,24,24,23,23,23,23,23,23,23,22,22,22,21,21,21,20,20,19,19,18,17,17,16
 dc.w 16,15,14,14,13,13,12,12,11,11,10,10,10,10,9,9,9,9,9,9,9,9,9,9,9,9,10,10,10,10,11,11
 dc.w 12,12,12,13,13,14,14,15,15,16,16,16,17,17,18,18,18,19,19,19,20,20,20,20,21,21,21,21,22,22,22,22
 dc.w 23,23,23,23,24,24,24,25,25,26,26,27,27,28,28,29,30,30,31,32,33,33,34,35,36,37,38,39,39,40,41,42
 dc.w 44,45,46,47,48,49,50,50,51,52,53,53,54,55,55,56,56,57,57,57,58,58,58,59,59,59,59,59,59,59,59,59
 dc.w 59,58,58,58,58,57,57,57,56,56,55,55,54,54,53,53,52,51,51,50,49,49,48,47,46,45,44,43,43,42,41,40
 dc.w 39,38,37,36,35,34,33,32,31,30,29,28,27,26,26,25,24,23,22,22,21,20,19,19,18,17,16,16,15,14,14,13
 dc.w 13,12,11,11,11,10,10,10,10,10,10,10,10,10,10,10,11,11,12,12,13,13,14,15,15,16,17,18,19,20,21,22
 dc.w 24,25,26,27,28,29,30,31,31,32,33,33,33,34,34,34,34,34,34,34,33,33,33,32,31,31,30,29,28,27,26,25
 dc.w 24,22,21,20,19,18,17,16,15,15,14,13,13,12,12,12,12,11,11,11,11,11,12,12,12,13,13,14,14,15,16,17
 dc.w 18,18,19,20,21,22,22,23,24,24,25,25,26,26,27,27,27,28,28,28,28,28,28,28,28,28,28,28,28,27,27,27
 dc.w 27,26,26,26,26,25,25,25,25,25,25,26,26,26,26,26,27,27,28,28,28,29,30,30,31,32,32,33,34,35,36,37
 dc.w 38,38,39,40,41,42,43,43,44,45,45,46,46,47,47,48,48,48,49,49,49,49,49,49,49,49,49,49,49,48,48,48
 dc.w 48,47,47,46,46,46,45,45,45,44,44,43,43,42,42,41,41,40,39,39,38,37,37,36,36,35,34,33,33,32,31,30
 dc.w 30,29,28,27,26,26,25,24,24,23,23,22,21,21,20,20,20,19,19,18,18,18,17,17,17,17,16,16,16,16,16,16
 dc.w 16,15,15,15,15,15,15,15,15,15,15,15,15,15,15,14,14,14,14,14,14,13,13,13,13,12,12,12,12,11,11,11
 dc.w 11,10,10,10,10,10,10,10,10,10,10,10,10,10,10,11,11,11,12,12,13,13,14,14,15,15,16,17,17,18,19,20
 dc.w 21,21,22,23,24,24,25,25,26,26,27,27,28,28,28,28,29,29,29,29,29,29,28,28,28,28,27,27,27,26,26,25
 dc.w 25,24,23,23,22,22,22,21,21,21,20,20,20,20,19,19,19,19,19,19,19,19,19,19,19,20,20,20,20,21,21,21
 dc.w 22,22,22,23,23,23,24,24,25,25,25,25,26,26,26,26,27,27,27,27,27,27,27,27,28,28,28,28,28,28,28,28
 dc.w 28,27,27,27,27,27,27,27,27,27,27,26,26,26,26,25,25,25,24,24,24,23,23,22,22,21,21,20,20,19,19,18
 dc.w 18,17,16,16,16,15,15,14,14,14,14,13,13,13,13,13,13,13,13,13,13,13,14,14,14,14,15,15,16,16,16,17
 dc.w 18,18,19,19,20,20,21,21,22,22,22,23,23,23,24,24,24,24,24,24,25,25,25,25,25,25,25,24,24,24,24,24
 dc.w 24,23,23,23,23,23,22,22,22,22,22,21,21,21,21,21,21,20,20,20,20,20,19,19,19,19,19,18,18,18,18,18
 dc.w 18,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,18,18,18,18,18,19,19,19,20,20,21,21,21,22,22,23
;repetition
 dc.w 24,24,25,25,26,26,26,27,27,27,27,28,28,28,28,28,28,27,27,27,27,26,26,25,25,24,24,23,23,22,21,20
 dc.w 20,19,18,17,17,16,16,15,15,15,15,15,15,15,15,15,16,16,17,17,18,19,20,21,22,23,24,25,26,28,29,31
 dc.w 33,34,36,37,39,40,42,43,44,46,47,48,49,50,50,51,52,53,53,54,54,55,55,55,55,55,56,56,55,55,55,55
 dc.w 55,54,54,53,53,53,52,52,51,51,51,50,50,49,49,49,48,48,47,47,47,46,46,45,45,45,44,44,43,43,42,42
 dc.w 42,41,41,40,40,39,39,38,38,37,37,36,36,35,35,34,34,33,33,32,32,31,31,30,30,29,29,28,28,27,27,26
 dc.w 26,25,24,24,23,23,23,22,22,21,21,21,21,20,20,20,20,20,19,19,19,19,19,19,19,19,19,20,20,20,20,20
 dc.w 21,21,21,21,21,21,21,22
 ;,22,22,22,21,21,21,21,21,21,21,20,20,20,19,19,19,18,18,17,17,16,15,15,14

Tubes: incbin 'SUPRSTAR\TUBE.XXX'