FontHeight=19

;IN  a6.l=@vram
;    a5.l=@text (ALL lines finished by 0, page finished by 255)
Print
  movem.l         d0-d7/a0-a6,-(sp)
  
  move.l        a5,a4
  moveq.l       #0,d7           ;d7=NbTextLines
.CountNbTextLines
  move.b        (a4)+,d0
  cmp.b         #255,d0
  beq.s         .NbTextLinesOk
  tst.b         d0
  bne.s         .CountNbTextLines
  addq.l        #1,d7
  bra.s         .CountNbTextLines
.NbTextLinesOk
  move.w        #FontHeight,d6
  mulu.w        d7,d6           ;d6=NbTextLines*FontHeight
  sub.l         #200,d6         ;d6=NbTextLines*FontHeight-200
  neg.l         d6              ;d6=200-NbTextLines*FontHeight
  move.l        d6,d5
  addq.l        #1,d7           ;d7=NbTextLines+1
  divu.w        d7,d5           ;d5=pixelsbetween=(200-NbTextLines*FontHeight)/(NbTextLines+1)
  move.w        d5,d4
  subq.l        #2,d7           ;d7=NbTextLines-1
  mulu.w        d7,d4           ;d4=totalpixelsbetween=pixelsbetween*(NbTextLines-1)
  sub.w         d4,d6           ;d6=200-NbTextLines*FontHeight-totalpixelsbetween
  lsr.w         #1,d6           ;d6=starty=(200-NbTextLines*FontHeight-totalpixelsbetween)/2
  mulu.w        #160,d6
  add.w         d6,a6           ;a6=@firstline
  add.w         #FontHeight,d5
  mulu.w        #160,d5         ;d5=(FontHeight+pixelsbetween)*160
  
.PrintOneLine  
  move.l          a5,a1
  move.b          (a5)+,d0
  tst.b           d0
  beq.s           .NextLine
  cmp.b           #255,d0
  beq.s           .TextFinished
;There is a line here, print it  
  move.l          a6,a0
  bsr.s           PrintLine
  move.l          a1,a5
  
.NextLine
  add.w           d5,a6         ;@vram+=(FontHeight+pixelsbetween)*160
  bra.s           .PrintOneLine
  
.TextFinished
  movem.l        (sp)+,d0-d7/a0-a6
  rts




;IN  a0.l=@where2draw
;    a1.l=@text (line finished by 0)
;OUT a1.l points after the 0
;    d0-d4/a2-a4 killed
PrintLine
  movem.l        a0/a5,-(sp)
  move.l         a1,a4
  lea            .conv_table(pc),a2
  lea            .lengths(pc),a3
  moveq.l        #$0,d0
  moveq.l        #$0,d1
.calc_length:
  move.b        (a4)+,d0            ;The ascii value of the char.
  tst.b         d0                  ;Null char at the end of the text.
  beq.s         .end_calc  
  move.b        (a2,d0.w),d0        ;Its position in a "normal" table.
  move.b        (a3,d0.w),d0        ;And finally its length.
  add.w         d0,d1               ;Add it to the string length.
  bra.s         .calc_length        ;Next char.

.end_calc:                          ;d1 contains the length.
  move.w        #320,d0
  sub.w         d1,d0
  lsr.w         #$1,d0              ;d0=(320-length)/2=x_pos for current char.
  
.print_one:
  moveq.l       #$0,d1
  move.b        (a1)+,d1            ;The char to print.
  tst.b         d1                  ;Null char?
  beq           .finished
  move.b        (a2,d1.w),d1        ;Its position in a "normal" table.

;d0=x
;d1=char number
;a0=@line
;a1=@text
;a2=.conv_table
;a3=.lengths

  moveq.l       #15,d2        ;mask
  move.w        d0,d3
  move.w        d3,d4
  and.w         d2,d4         ;d4=x mod(16)
  sub.w         d4,d3         ;d3=x-x mod(16)
  lsr.w         #1,d3         ;d3=(x-x mod(16))/2
  sub.w         d4,d2         ;d2=15-x mod(16)
  move.l        a0,a4
  add.w         d3,a4         ;a4=@dest
  
  move.b        (a3,d1.w),d4  ;d4=length of char
  add.w         d4,d0         ;d0=next x
  
  lea           .fonts(pc),a5
  mulu.w        #76,d1        ;76 bytes per char
  add.w         d1,a5         ;a5 points on char
 REPT FontHeight
  moveq.l       #0,d1
  move.w        (a5)+,d1
  lsl.l         d2,d1
  or.w          d1,8(a4)
  swap.w        d1
  or.w          d1,(a4)+
  moveq.l       #0,d1
  move.w        (a5)+,d1
  lsl.l         d2,d1
  or.w          d1,8(a4)
  swap.w        d1
  or.w          d1,(a4)+
  add.w         #160-4,a4
 ENDR
  
  bra        .print_one

.finished:  
  movem.l        (sp)+,a0/a5
  rts

.conv_table:
  dc.b        00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
  dc.b        00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
  dc.b        00,68,00,00,00,00,53,69,54,55,00,00,00,00,70,56
  dc.b        57,58,59,60,61,62,63,64,65,66,00,00,00,00,00,67
  dc.b        00,01,02,03,04,05,06,07,08,09,10,11,12,13,14,15
  dc.b        16,17,18,19,20,21,22,23,24,25,26,00,00,00,00,00
  dc.b        00,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41
  dc.b        42,43,44,45,46,47,48,49,50,51,52,00,00,00,00,00
      
.lengths:
  dc.b        8,12,13,13,14,10,16,13,16,13,12,11,12,16,15,12,12
  dc.b        13,15,15,15,12,15,16,16,11,16,8,7,6,7,7,7,8,8,5
  dc.b        6,8,6,11,7,7,10,9,7,6,6,8,8,11,8,8,7,9,6,7,9,9,7
  dc.b        8,8,9,8,8,9,8,8,7,5,4,4

  even
  
.fonts:
;  dc.w        0
;2bpp, h=19
;space A>Z a>z & ( ) / 0>9 ? ! ' .
  incbin        'SUPRSTAR\FONTS.XXX'
